/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package uio.amg.zhong.jasmine;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

/**
 * NB!!! this class only use for temporary analysis. NOT put it into pipeline
 * 
 * @author xiangfuz
 */
class TemporaryMethods {
    
    Logger logger = LogManager.getRootLogger();
    HashMap<String, String> speciesCommon_IDhash;
    HashMap<String, String> speciesCommon_IDSeqHash;
    ArrayList<String> singleFormArray ;

    private  void sameSequence() throws IOException {
        
        /*
        read in all needed list
        */
        String topExpressedGeFilestr = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/GeData/IsomiRsReports/GeData.topExpressedList.tsv";
        JASMINEutility misoUtility  = new JASMINEutility();
        misoUtility.readSingleColumn(topExpressedGeFilestr);
        ArrayList<String> topExpressedGe = misoUtility.getSingleCol();
        
        String topExpressedHuangFilestr = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/HuangData/IsomiRsReports/HuangData.topExpressedList.tsv";
        misoUtility.readSingleColumn(topExpressedHuangFilestr);
        ArrayList<String> topExpressedHuang = misoUtility.getSingleCol();
        
        String topExpressedYuanFilestr = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/YuanData/IsomiRsReports/YuanData.topExpressedList.tsv";
        misoUtility.readSingleColumn(topExpressedYuanFilestr);
        ArrayList<String> topExpressedYuan = misoUtility.getSingleCol();
        
        String topExpressedNogalesCadenasFilestr = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/NogalesCadenasData/IsomiRsReports/NogalesCadenasData.topExpressedList.tsv";
        misoUtility.readSingleColumn(topExpressedNogalesCadenasFilestr);
        ArrayList<String> topExpressedNogalesCadenas = misoUtility.getSingleCol();
        
        /*
        extract same items in two list
        */
        ArrayList<String> mmuShared = extractShared(topExpressedGe, topExpressedNogalesCadenas);
        ArrayList<String> hsaShared = extractShared(topExpressedHuang, topExpressedYuan);
        
        /*
        get same sequence item between hsa and mmu
        */
        ArrayList<String> sameSeqShared = getSameSeqStrEntry(hsaShared,mmuShared);
        
        misoUtility.writeStrArrayList("/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/", "isomiRnomenclature", sameSeqShared, ".sameSeqStr.in4projects.tsv");
        
    }

    void start() throws IOException {
//        sameSequence();
        
        speciesCommonMiR();
        
        fetchData4Comm();
    }

    private ArrayList<String> extractShared(ArrayList<String> topExpressedA, ArrayList<String> topExpressedB) {
        ArrayList<String> sharedArray = new ArrayList<>();
        
        for(String iEntryStr : topExpressedA ){
            if(!iEntryStr.contains("*")){
                if(topExpressedB.contains(iEntryStr)){
                    sharedArray.add(iEntryStr);
                }
            }
        }
        return sharedArray;
    }

    private ArrayList<String> getSameSeqStrEntry(ArrayList<String> hsaShared, ArrayList<String> mmuShared) throws IOException {
        JASMINEutility misoUtility  = new JASMINEutility();
        
        ArrayList<String> sameSeqStrEntry = new ArrayList<>();
        
        logger.info("HOW MANY SHARED IN HSA:-->  " + String.valueOf(hsaShared.size()));
        logger.info("HOW MANY SHARED IN MMU:-->  " + String.valueOf(mmuShared.size()));
        
        String uniqueMMUfastaFileString = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/NogalesCadenasData/Reference/miRBase21.mmu.unique.mature.fasta";
        String uniqueHSAfastaFileString = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/YuanData/Reference/miRBase21.hsa.unique.mature.fasta";
        
        misoUtility.readFasta(uniqueHSAfastaFileString);
        HashMap<String, String> uniqueHSAfastqHash = misoUtility.getSeqStrNameHash();
        
        misoUtility.readFasta(uniqueMMUfastaFileString);
        HashMap<String, String> uniqueMMUfastqHash = misoUtility.getSeqStrNameHash();
        
        logger.info("HOW MANY SHARED IN HSA:-->  " + String.valueOf(uniqueHSAfastqHash.size()));
        logger.info("HOW MANY SHARED IN MMU:-->  " + String.valueOf(uniqueMMUfastqHash.size()));
        
        for(String iHSAentry : hsaShared ){
            if(uniqueHSAfastqHash.containsKey(iHSAentry.trim())){
                String iHSAentrySeqStr = uniqueHSAfastqHash.get(iHSAentry).trim();
                for(String iMMUentry : mmuShared ){
                    if(uniqueMMUfastqHash.containsKey(iMMUentry.trim())){
                        String iMMUentrySeqStr = uniqueMMUfastqHash.get(iMMUentry);
                        if(iHSAentrySeqStr.equals(iMMUentrySeqStr)){
                            String tmpstr = iHSAentry +"|"+ iMMUentry +"\t"+iHSAentry +"\t"+ iMMUentry +"\t"+ iHSAentrySeqStr +"\t"+ iMMUentrySeqStr;
                            sameSeqStrEntry.add(tmpstr);
                            logger.info(tmpstr);
                        }
                    }
                    else{
                        logger.info("COULD NOT FIND THIS in mmu: --->  " + iMMUentry);
                    }
                }
            }
            else{
                logger.info("COULD NOT FIND THIS in hsa: --->  " + iHSAentry);
            }  
        }
        
        ArrayList<String> identicalSeqIDarray = new ArrayList<>();
        for (Map.Entry<String, String> hsaEntry : uniqueHSAfastqHash.entrySet()) {
            String hsaEntryID  = hsaEntry.getKey();
            String  hsaEntrySeq = hsaEntry.getValue();
            
            for (Map.Entry<String, String> mmuEntry
                    : uniqueMMUfastqHash.entrySet()) {
                String  mmuEntryID = mmuEntry.getKey();
                String mmuEntrySeq  = mmuEntry.getValue();
                
                if(hsaEntrySeq.equals(mmuEntrySeq)){
                    identicalSeqIDarray.add(hsaEntryID+"|"+mmuEntryID);
                }
                
                
            }
            
        }
        logger.info("number of entries shares seq   ----- "+identicalSeqIDarray.size());
        return sameSeqStrEntry;
        
//        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    /**
     * this method is to find out miRNAs that have same mature sequence between human and mouse
     */
    private void speciesCommonMiR() throws IOException {
        speciesCommon_IDSeqHash = new HashMap<>();
        speciesCommon_IDhash = new HashMap<>();
        
        JASMINEutility misoUtility  = new JASMINEutility();
        
        ArrayList<String> sameSeqStrEntry = new ArrayList<>();
        
        String uniqueMMUfastaFileString = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/NogalesCadenasData/Reference/miRBase21.mmu.unique.mature.fasta";
        String uniqueHSAfastaFileString = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/YuanData/Reference/miRBase21.hsa.unique.mature.fasta";
        
        misoUtility.readFasta(uniqueHSAfastaFileString);
        HashMap<String, String> uniqueHSAfastqHash = misoUtility.getSeqStrNameHash();
        
        misoUtility.readFasta(uniqueMMUfastaFileString);
        HashMap<String, String> uniqueMMUfastqHash = misoUtility.getSeqStrNameHash();
        
        for (Map.Entry<String, String> hsaEntry : uniqueHSAfastqHash.entrySet()) {
            String hsaMirID = hsaEntry.getKey();
            String hsaMirSeq = hsaEntry.getValue();
            
            for (Map.Entry<String, String> mmuEntry : uniqueMMUfastqHash.entrySet()) {
                String mmuMirID = mmuEntry.getKey();
                String mmuMirSeq = mmuEntry.getValue();
                
                if(hsaMirSeq.equals(mmuMirSeq)){
                    String hsaTmpID = hsaMirID.substring(4);
                    String mmuTmpID = mmuMirID.substring(4);
                    if(hsaTmpID.equals(mmuTmpID)){
                        speciesCommon_IDhash.put(mmuMirID, hsaTmpID);
                        speciesCommon_IDhash.put(hsaMirID, hsaTmpID);
                    }
                    else{
                        speciesCommon_IDhash.put(mmuMirID, (hsaMirID+"|"+mmuMirID));
                        speciesCommon_IDhash.put(hsaMirID, (hsaMirID+"|"+mmuMirID));
                    }
                }
                
            }
            
        }
        
        logger.info(speciesCommon_IDhash.size());
        
        
//        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    /**
     * this is to get read count for those species common miRNAs
     */
    private void fetchData4Comm() throws IOException {
        String mouseProj1Tsv = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/NogalesCadenasData/configs/mirna-hairpin.tsv";
        String mouseProj2Tsv = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/GeData/configs/mirna-isoform.tsv";
        String humanProj1Tsv = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/YuanData/configs/mirnaYuan.tsv";
        String humanProj2Tsv = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/HuangData/configs/mirna-isoform-hairpin.tsv";
        
        String mouseProj1TargetFolder = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/NogalesCadenasData/IsomiRsReports/";
        String mouseProj2TargetFolder = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/GeData/IsomiRsReports/";
        String humanProj1TargetFolder = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/YuanData/IsomiRsReports/";
        String humanProj2TargetFolder = "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/HuangData/IsomiRsReports/";
        
        /*
        build job work flow hash
        */
        HashMap<String, String> fetchDataJob = new HashMap<>();
//        fetchDataJob.put(mouseProj1Tsv, mouseProj1TargetFolder);
//        fetchDataJob.put(mouseProj2Tsv, mouseProj2TargetFolder);
//        fetchDataJob.put(humanProj1Tsv, humanProj1TargetFolder);
//        fetchDataJob.put(humanProj2Tsv, humanProj2TargetFolder);
        fetchDataJob.put("/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/okayamaUData/configs/mirna-isoform.tsv", "/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/okayamaUData/IsomiRsReports/");
        
        singleFormArray = new ArrayList<>();
                
        /*
        iterate to fetch read count
        */
        for (Map.Entry<String, String> projEntry : fetchDataJob.entrySet()) {
            String projTSV = projEntry.getKey();
            String projFOLDER = projEntry.getValue();
            
            ArrayList<String> datalistProj = readCleanDatasetList(projTSV);
            for(String idataset : datalistProj){
                String idatasetFullPath = projFOLDER+idataset+".isomiRs.report.tsv";
                parseIsomiRReport(idatasetFullPath);
                checkDistributation(idatasetFullPath);
            }
            
        }
        JASMINEutility misoUtility  = new JASMINEutility();
        misoUtility.writeStrArrayList("/Users/xiangfuz/Documents/ngsProjects/isomiR-nomenclature/figures/", "okayamaUData.singleFormDist", singleFormArray, ".tsv");
        
        
//        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    private ArrayList<String> readCleanDatasetList(String projTSV) throws IOException {
        ArrayList<String> cleanDatalist  = new ArrayList<>();
        try{
            logger.info("reading mapping summary file <" +  projTSV + ">");
            BufferedReader sralistBR = new BufferedReader(new FileReader(new File(projTSV)));
            String lineStr = null;
            while ((lineStr = sralistBR.readLine())!=null){
                if(lineStr.startsWith("File")) continue;
                String cleanDatasetSt = lineStr.trim().split("\t")[0].replace(".fastq.gz", "");
                cleanDatalist.add(cleanDatasetSt);
            }
            sralistBR.close();
            logger.info("read " + cleanDatalist.size() + " entries");
            logger.info("done");
        }
        catch(IOException ex){
            logger.error("error reading mapping summary file <" +  projTSV + ">\n" + ex.toString());
            throw new IOException("error reading mapping summary file <" +  projTSV + ">");
        }
        return cleanDatalist;
//        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    private void parseIsomiRReport(String idatasetFullPath) throws IOException {
        try{
            logger.info("reading mapping summary file <" +  idatasetFullPath + ">");
            BufferedReader reportBR = new BufferedReader(new FileReader(new File(idatasetFullPath)));
            String lineStr = null;
            while ((lineStr = reportBR.readLine())!=null){
                String[] lineStrArray = lineStr.trim().split("\t");
                
                if(!lineStrArray[2].contains("*")){
                    if(speciesCommon_IDhash.containsKey(lineStrArray[2])){
                        String commonMirID = speciesCommon_IDhash.get(lineStrArray[2]);
                        String tmpMergedStr = lineStrArray[0] +"\t"+ commonMirID +"\t"+ commonMirID +":"+lineStrArray[5]+"#"+lineStrArray[6] +"\t"+ lineStrArray[4];
                        singleFormArray.add(tmpMergedStr);
                    }
                }
                
//                if(lineStr.startsWith("File")) continue;
//                String cleanDatasetSt = lineStr.trim().split("\t")[0].replace(".fastq.gz", "");
//                cleanDatalist.add(cleanDatasetSt);
            }
            reportBR.close();
//            logger.info("read " + cleanDatalist.size() + " entries");
            logger.info("done");
        }
        catch(IOException ex){
            logger.error("error reading mapping summary file <" +  idatasetFullPath + ">\n" + ex.toString());
            throw new IOException("error reading mapping summary file <" +  idatasetFullPath + ">");
        }
        
//        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    private void checkDistributation(String idatasetFullPath) throws IOException {
        
        try{
            logger.info("reading mapping summary file <" +  idatasetFullPath + ">");
            BufferedReader reportBR = new BufferedReader(new FileReader(new File(idatasetFullPath)));
            String lineStr = null;
            while ((lineStr = reportBR.readLine())!=null){
                String[] lineStrArray = lineStr.trim().split("\t");
                
                
                
                if(!lineStrArray[2].contains("*")){
                    if(speciesCommon_IDhash.containsKey(lineStrArray[2])){
                        String commonMirID = speciesCommon_IDhash.get(lineStrArray[2]);
                        String tmpMergedStr = lineStrArray[0] +"\t"+ commonMirID +"\t"+ lineStrArray[3]+"#"+lineStrArray[6] +"\t"+ lineStrArray[4];
                        singleFormArray.add(tmpMergedStr);
                    }
                }
                
                
            }
            reportBR.close();
            logger.info("done");
        }
        catch(IOException ex){
            logger.error("error reading mapping summary file <" +  idatasetFullPath + ">\n" + ex.toString());
            throw new IOException("error reading mapping summary file <" +  idatasetFullPath + ">");
        }
    }
    
    
    
    
}
